
/**
 * A class to hold some examples of string manipulation.
 * 
 * @author Stephen Bloch 
 * @version Sept 4, 2002
 */
public class Testbed
{
	/**
	 * Test method -- every class should have one.
	 * 
	 * @param stringParam, a parameter to allow you to experiment with different strings
	 */
	public static void test(String stringParam)
	{
		System.out.println("Welcome to FunWithStrings!");
		
		System.out.println ("The parameter was " + stringParam + ".");
		System.out.println ("In lower-case, " + stringParam.toLowerCase() + ".");
		System.out.println ("In upper-case, " + stringParam.toUpperCase() + ".");
		System.out.println ("It is " + stringParam.length() + " letters long.");
		System.out.println ("The name of my University, in upper case, is " + "Adelphi".toUpperCase() + ".");
		System.out.println ("It is " + "Adelphi".length() + " letters long.");
		// Make up more examples using +, toLowerCase, toUpperCase, and length.
		// For each example, predict what you think it'll do; then try it, both interactively and by adding
		// a line to this program.  If it doesn't produce the answer you expected, try some more experiments
		// and figure out why.
		
		String myName = "Stephen Bloch";
		System.out.println ("My name is " + myName + ".");
		String favoriteColor; // has no value at all yet!
		// System.out.println ("My favorite color is " + favoriteColor + ".");
		// Try un-commenting the above statement and see what happens.
		
		favoriteColor = "blue";
		System.out.println ("Now my favorite color is " + favoriteColor + ".");
		// Note that favoriteColor has changed.
		
		System.out.println ("Another way to concatenate: my favorite color is ".concat(favoriteColor).concat("."));
		// Anything you can do using + on Strings can also be done using concat, and vice versa.
		// Usually + is shorter and more convenient, but you should know both.
		// Make up some more examples using concat.
		
		System.out.println ("My name in quotation marks is \"" + myName + "\".");
		// Note that if you want to put a quotation mark inside a quoted string, you have to
		// precede it with a backslash so Java doesn't think it's the end of the string.
		
		System.out.println ("Here's part of my name: \"" + myName.substring(4) +
			"\" (should be \"hen Bloch\").");
			// Note that if a statement gets too long, you can go on to the next line; Java doesn't care.
		System.out.println 
			(
			"That part is " 
			+
			myName
			.
			substring
			(
			4
			)
			.
			length
			(
			) 
			+
			" letters long."
			)
			;
		// That was an extreme example of breaking a statement into several lines.  Don't go that far!
		
		System.out.println ("Here's another part: \"" + myName.substring(4,6) + "\" (should be \"he\").");
		System.out.println ("That part is " + myName.substring(4,6).length() + " letters long.");
		// Make up more examples using substring.

		String otherColor = favoriteColor + "-green";
		System.out.println ("My favorite color is still " + favoriteColor + ", but I like " + otherColor + " too.");
		
		System.out.println ("I'm looking for the letter \"e\" in my name: " +
			myName.indexOf("e") + ".");
		System.out.println ("How about the letters \"he\"?" + myName.indexOf("he"));
		System.out.println ("How about the letters \"rx\"?" + myName.indexOf("rx"));
		System.out.println ("How about the letters \"Ste\"?" + myName.indexOf("Ste"));
		System.out.println ("And the letters \"ste\"?" + myName.indexOf("ste"));
		// Make up more examples using indexOf.
		
		System.out.println ("Is my name the same as \"Jeff\"?" + myName.equals("Jeff"));
		System.out.println ("Is my name the same as \"Stephen Bloch\"?" + 
			myName.equals("Stephen Bloch"));
		System.out.println ("Is my name the same as \"stephen bloch\"?" +
			myName.equals("stephen bloch"));
		System.out.println ("What if I ignore case?" +
			myName.equalsIgnoreCase("stephen bloch"));
		// Make up more examples with equals and equalsIgnoreCase.
		
		String weirdColor = otherColor.replaceAll("e","fg");
		// Note: if you have Java version 1.3, rather than 1.4, this line won't work.
		System.out.println ("A weird color name: \"" + weirdColor + "\" (should be \"blufg-grfgfgn\".)");
		System.out.println ("otherColor is still \"" + otherColor + "\".");
		System.out.println ("Another replacement: \"" + weirdColor.replaceFirst("g","xyz") + 
			"\" (should be \"blufxyz-grfgfgn\".)");
		// Make up more examples with replaceAll and replaceFirst.
		
		// Look up some other String methods in http://java.sun.com/j2se/1.4/docs/api/java/lang/String.html
		// such as compareTo, endsWith, startsWith, lastIndexOf, and trim.  Make up examples using them,
		// predict the answers, try them, and see whether your prediction was correct.
	}
}
